%---------GALE - SHAPLEY ALGORITHM (Men propose) --------%
function stablematch = gale_shapley(N, men_pref, women_pref)
% function stablematch = gale_shapley(N, men_pref, women_pref)

men_free = zeros(N,1);
women_suitor = zeros(N,N);
women_partner = zeros(N,1);
rank = zeros(N,N);

for i = 1:N
    for j = 1:N
        for k = 1:N
            if(women_pref(i,k) == j)
                rank(i,j) = k;
            end
        end
    end
end

while (min(women_partner) == 0)
    for i = 1:N
        if (men_free(i,1) == 0)
            next = find(men_pref(i,:) > 0, 1);
            women_suitor(men_pref(i,next),i) = i;
            men_pref(i,next) = 0;
        end
    end
    
    for i = 1:N
        for j = 1:N
            if(women_suitor(i,j) ~= 0)
                if(women_partner(i,1) == 0)
                    women_partner(i,1) = women_suitor(i,j);
                    men_free(j,1) = 1;
                end
                if(women_partner(i,1) ~= 0)
                    if(rank(i,women_suitor(i,j)) < rank(i,women_partner(i,1)))
                        men_free(women_partner(i,1),1) = 0;
                        women_partner(i,1) = women_suitor(i,j);
                        men_free(j,1) = 1;
                        
                    end
                end
            end
        end
    end
end

stablematch = women_partner;

% Copyright (c) 2013, Sanjith Gopalakrishnan
% All rights reserved.
% 
% Redistribution and use in source and binary forms, with or without
% modification, are permitted provided that the following conditions are met:
% 
% * Redistributions of source code must retain the above copyright notice, this
%   list of conditions and the following disclaimer.
% 
% * Redistributions in binary form must reproduce the above copyright notice,
%   this list of conditions and the following disclaimer in the documentation
%   and/or other materials provided with the distribution
% THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
% AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
% IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
% DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE
% FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
% DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
% SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
% CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
% OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
% OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

