function plot2D_contour(M,xVec,yVec,sig_name,fig_name)
% function plot2D_contour(M,xVec,yVec,sig_name,fig_name)
% This function produces contour plots of 2D spectra M
% Inputs :
%           M : 2D spectra to be plot
%           xVec,yVec : x and y frequency axes in Hz
% Output : no output variable

%% 2D dimensions
L1 = length(xVec);
L2 = length(yVec);

%% conversion of Hz to ppm
xVec = xVec/150.86;
yVec = yVec/600;

%% Come back to 2D
K=size(M,1);
M = reshape(M,K,L1,L2);

%% Contour plots
k=floor(sqrt(K));
l=ceil(K/k);

figure;

for n=1:K
    subplot(k,l,n)
    contour(yVec,xVec,squeeze(M(n,:,:)),20,'r');
    set(gca,'xdir','reverse','ydir','reverse');
    xlabel('^1H (ppm)');
    ylabel('^{13}C (ppm)');
    grid;
    title(sig_name{n})
end
if exist ('OCTAVE_VERSION', 'builtin')
    axes( 'visible', 'off', 'title', fig_name );
else
    sgtitle(fig_name );
end