function [S_est, A_est, perm] = reorderAS( S_ref,S_est, A_est)
% reorderAS:    Fix the permutation indeterminacy using Gale-Shapley algo
% usage:    [S_est, A_est, perm] = reorderAS(S_ref, S_est, A_est)
% 
% Input variables:
%   S_ref: reference sources, NbSrc * NbPts array
%   S_est: estimated sources, NbSrc * NbPts array
%   A_est: estimated mixing matrix, NbObs * NbSrc array
%
% Output variables:
%   S_est: reordered sources, NbSrc * NbPts array
%   A_est: reodered mixing matrix, NbObs * NbSrc array
%   perm: permutation, vector of length NbSrC 

[S_est, perm] = permuteSources(S_ref, S_est);
A_est = A_est(:,perm);

end